'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _webpackSources = require('webpack-sources');

var _utils = require('../../utils');

var _constants = require('../../../lib/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// This plugin creates a pages-manifest.json from page entrypoints.
// This is used for mapping paths like `/` to `.next/dist/bundles/pages/index.js` when doing SSR
// It's also used by next export to provide defaultPathMap
var PagesManifestPlugin = function () {
  function PagesManifestPlugin() {
    (0, _classCallCheck3.default)(this, PagesManifestPlugin);
  }

  (0, _createClass3.default)(PagesManifestPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      compiler.plugin('emit', function (compilation, callback) {
        var entries = compilation.entries;

        var pages = {};

        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = (0, _getIterator3.default)(entries), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var entry = _step.value;

            var pagePath = _utils.MATCH_ROUTE_NAME.exec(entry.name)[1];

            if (!pagePath) {
              continue;
            }

            var name = entry.name;

            pages['/' + pagePath.replace(/\\/g, '/')] = name;
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        compilation.assets[_constants.PAGES_MANIFEST] = new _webpackSources.RawSource((0, _stringify2.default)(pages));
        callback();
      });
    }
  }]);
  return PagesManifestPlugin;
}();

exports.default = PagesManifestPlugin;