'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _del = require('del');

var _del2 = _interopRequireDefault(_del);

var _recursiveCopy = require('recursive-copy');

var _recursiveCopy2 = _interopRequireDefault(_recursiveCopy);

var _mkdirpThen = require('mkdirp-then');

var _mkdirpThen2 = _interopRequireDefault(_mkdirpThen);

var _walk = require('walk');

var _walk2 = _interopRequireDefault(_walk);

var _path = require('path');

var _fs = require('fs');

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _constants = require('../lib/constants');

var _render = require('./render');

var _utils = require('./utils');

var _asset = require('../lib/asset');

var _runtimeConfig = require('../lib/runtime-config');

var envConfig = _interopRequireWildcard(_runtimeConfig);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(dir, options, configuration) {
    var _this = this;

    var nextConfig, nextDir, buildId, pagesManifest, pages, defaultPathMap, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, page, outDir, exportPathMap, exportPaths, renderOpts, serverRuntimeConfig, publicRuntimeConfig, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, path, _exportPathMap$path, _page, _exportPathMap$path$q, query, req, res, htmlFilename, baseDir, htmlFilepath, html, log;

    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            log = function log(message) {
              if (options.silent) return;
              console.log(message);
            };

            dir = (0, _path.resolve)(dir);
            nextConfig = configuration || (0, _config2.default)(_constants.PHASE_EXPORT, dir);
            nextDir = (0, _path.join)(dir, nextConfig.distDir);


            log('> using build directory: ' + nextDir);

            if (!(0, _fs.existsSync)(nextDir)) {
              console.error('Build directory ' + nextDir + ' does not exist. Make sure you run "next build" before running "next start" or "next export".');
              process.exit(1);
            }

            buildId = (0, _fs.readFileSync)((0, _path.join)(nextDir, 'BUILD_ID'), 'utf8');
            pagesManifest = require((0, _path.join)(nextDir, 'dist', _constants.PAGES_MANIFEST));
            pages = (0, _keys2.default)(pagesManifest);
            defaultPathMap = {};
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context2.prev = 13;
            _iterator = (0, _getIterator3.default)(pages);

          case 15:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context2.next = 23;
              break;
            }

            page = _step.value;

            if (!(page === '/_document')) {
              _context2.next = 19;
              break;
            }

            return _context2.abrupt('continue', 20);

          case 19:
            defaultPathMap[page] = { page: page };

          case 20:
            _iteratorNormalCompletion = true;
            _context2.next = 15;
            break;

          case 23:
            _context2.next = 29;
            break;

          case 25:
            _context2.prev = 25;
            _context2.t0 = _context2['catch'](13);
            _didIteratorError = true;
            _iteratorError = _context2.t0;

          case 29:
            _context2.prev = 29;
            _context2.prev = 30;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 32:
            _context2.prev = 32;

            if (!_didIteratorError) {
              _context2.next = 35;
              break;
            }

            throw _iteratorError;

          case 35:
            return _context2.finish(32);

          case 36:
            return _context2.finish(29);

          case 37:

            // Initialize the output directory
            outDir = options.outdir;
            _context2.next = 40;
            return (0, _del2.default)((0, _path.join)(outDir, '*'));

          case 40:
            _context2.next = 42;
            return (0, _mkdirpThen2.default)((0, _path.join)(outDir, '_next', buildId));

          case 42:
            if (!(0, _fs.existsSync)((0, _path.join)(dir, 'static'))) {
              _context2.next = 46;
              break;
            }

            log('  copying "static" directory');
            _context2.next = 46;
            return (0, _recursiveCopy2.default)((0, _path.join)(dir, 'static'), (0, _path.join)(outDir, 'static'), { expand: true });

          case 46:
            _context2.next = 48;
            return (0, _recursiveCopy2.default)((0, _path.join)(nextDir, 'main.js'), (0, _path.join)(outDir, '_next', buildId, 'main.js'));

          case 48:
            if (!(0, _fs.existsSync)((0, _path.join)(nextDir, 'static'))) {
              _context2.next = 52;
              break;
            }

            log('  copying "static build" directory');
            _context2.next = 52;
            return (0, _recursiveCopy2.default)((0, _path.join)(nextDir, 'static'), (0, _path.join)(outDir, '_next', 'static'));

          case 52:
            if (!(0, _fs.existsSync)((0, _path.join)(nextDir, 'chunks'))) {
              _context2.next = 58;
              break;
            }

            log('  copying dynamic import chunks');

            _context2.next = 56;
            return (0, _mkdirpThen2.default)((0, _path.join)(outDir, '_next', 'webpack'));

          case 56:
            _context2.next = 58;
            return (0, _recursiveCopy2.default)((0, _path.join)(nextDir, 'chunks'), (0, _path.join)(outDir, '_next', 'webpack', 'chunks'));

          case 58:
            _context2.next = 60;
            return copyPages(nextDir, outDir, buildId);

          case 60:

            // Get the exportPathMap from the `next.config.js`
            if (typeof nextConfig.exportPathMap !== 'function') {
              console.log('> No "exportPathMap" found in "next.config.js". Generating map from "./pages"');
              nextConfig.exportPathMap = function () {
                var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(defaultMap) {
                  return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          return _context.abrupt('return', defaultMap);

                        case 1:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, _this);
                }));

                return function (_x4) {
                  return _ref2.apply(this, arguments);
                };
              }();
            }

            _context2.next = 63;
            return nextConfig.exportPathMap(defaultPathMap);

          case 63:
            exportPathMap = _context2.sent;
            exportPaths = (0, _keys2.default)(exportPathMap);

            // Start the rendering process

            renderOpts = {
              dir: dir,
              dist: nextConfig.distDir,
              buildId: buildId,
              nextExport: true,
              assetPrefix: nextConfig.assetPrefix.replace(/\/$/, ''),
              dev: false,
              staticMarkup: false,
              hotReloader: null,
              availableChunks: (0, _utils.getAvailableChunks)(dir, nextConfig.distDir)
            };
            serverRuntimeConfig = nextConfig.serverRuntimeConfig, publicRuntimeConfig = nextConfig.publicRuntimeConfig;


            if (publicRuntimeConfig) {
              renderOpts.runtimeConfig = publicRuntimeConfig;
            }

            envConfig.setConfig({
              serverRuntimeConfig: serverRuntimeConfig,
              publicRuntimeConfig: publicRuntimeConfig
            });

            // set the assetPrefix to use for 'next/asset'
            (0, _asset.setAssetPrefix)(renderOpts.assetPrefix);

            // We need this for server rendering the Link component.
            global.__NEXT_DATA__ = {
              nextExport: true
            };

            _iteratorNormalCompletion2 = true;
            _didIteratorError2 = false;
            _iteratorError2 = undefined;
            _context2.prev = 74;
            _iterator2 = (0, _getIterator3.default)(exportPaths);

          case 76:
            if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
              _context2.next = 97;
              break;
            }

            path = _step2.value;

            log('> exporting path: ' + path);

            if (path.startsWith('/')) {
              _context2.next = 81;
              break;
            }

            throw new Error('path "' + path + '" doesn\'t start with a backslash');

          case 81:
            _exportPathMap$path = exportPathMap[path], _page = _exportPathMap$path.page, _exportPathMap$path$q = _exportPathMap$path.query, query = _exportPathMap$path$q === undefined ? {} : _exportPathMap$path$q;
            req = { url: path };
            res = {};
            htmlFilename = '' + path + _path.sep + 'index.html';

            if ((0, _path.extname)(path) !== '') {
              // If the path has an extension, use that as the filename instead
              htmlFilename = path;
            } else if (path === '/') {
              // If the path is the root, just use index.html
              htmlFilename = 'index.html';
            }
            baseDir = (0, _path.join)(outDir, (0, _path.dirname)(htmlFilename));
            htmlFilepath = (0, _path.join)(outDir, htmlFilename);
            _context2.next = 90;
            return (0, _mkdirpThen2.default)(baseDir);

          case 90:
            _context2.next = 92;
            return (0, _render.renderToHTML)(req, res, _page, query, renderOpts);

          case 92:
            html = _context2.sent;

            (0, _fs.writeFileSync)(htmlFilepath, html, 'utf8');

          case 94:
            _iteratorNormalCompletion2 = true;
            _context2.next = 76;
            break;

          case 97:
            _context2.next = 103;
            break;

          case 99:
            _context2.prev = 99;
            _context2.t1 = _context2['catch'](74);
            _didIteratorError2 = true;
            _iteratorError2 = _context2.t1;

          case 103:
            _context2.prev = 103;
            _context2.prev = 104;

            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }

          case 106:
            _context2.prev = 106;

            if (!_didIteratorError2) {
              _context2.next = 109;
              break;
            }

            throw _iteratorError2;

          case 109:
            return _context2.finish(106);

          case 110:
            return _context2.finish(103);

          case 111:

            // Add an empty line to the console for the better readability.
            log('');

          case 112:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[13, 25, 29, 37], [30,, 32, 36], [74, 99, 103, 111], [104,, 106, 110]]);
  }));

  return function (_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

function copyPages(nextDir, outDir, buildId) {
  // TODO: do some proper error handling
  return new _promise2.default(function (resolve, reject) {
    var nextBundlesDir = (0, _path.join)(nextDir, 'bundles', 'pages');
    var walker = _walk2.default.walk(nextBundlesDir, { followLinks: false });

    walker.on('file', function (root, stat, next) {
      var filename = stat.name;
      var fullFilePath = '' + root + _path.sep + filename;
      var relativeFilePath = fullFilePath.replace(nextBundlesDir, '');

      // We should not expose this page to the client side since
      // it has no use in the client side.
      if (relativeFilePath === _path.sep + '_document.js') {
        next();
        return;
      }

      var destFilePath = null;
      if (relativeFilePath === _path.sep + 'index.js') {
        destFilePath = (0, _path.join)(outDir, '_next', buildId, 'page', relativeFilePath);
      } else if (/index\.js$/.test(filename)) {
        var newRelativeFilePath = relativeFilePath.replace(_path.sep + 'index.js', '.js');
        destFilePath = (0, _path.join)(outDir, '_next', buildId, 'page', newRelativeFilePath);
      } else {
        destFilePath = (0, _path.join)(outDir, '_next', buildId, 'page', relativeFilePath);
      }

      (0, _recursiveCopy2.default)(fullFilePath, destFilePath).then(next).catch(reject);
    });

    walker.on('end', resolve);
  });
}