'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _symbol = require('babel-runtime/core-js/symbol');

var _symbol2 = _interopRequireDefault(_symbol);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var kCustomPromisifyArgsSymbol = (0, _symbol2.default)('customPromisifyArgs');
module.exports = function promisify(original) {
  // Names to create an object from in case the callback receives multiple
  // arguments, e.g. ['stdout', 'stderr'] for child_process.exec.
  var argumentNames = original[kCustomPromisifyArgsSymbol];

  return function fn() {
    var _this = this;

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return new _promise2.default(function (resolve, reject) {
      try {
        original.call.apply(original, [_this].concat(args, [function (err) {
          for (var _len2 = arguments.length, values = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
            values[_key2 - 1] = arguments[_key2];
          }

          if (err) {
            reject(err);
          } else if (argumentNames !== undefined && values.length > 1) {
            var obj = {};
            for (var i = 0; i < argumentNames.length; i++) {
              obj[argumentNames[i]] = values[i];
            }
            resolve(obj);
          } else {
            resolve(values[0]);
          }
        }]));
      } catch (err) {
        reject(err);
      }
    });
  };
};